import collections.abc
import typing

import httplib2
import typing_extensions

import googleapiclient.discovery
import googleapiclient.http

from .schemas import *

_list = list

@typing.type_check_only
class MerchantResource(googleapiclient.discovery.Resource):
    @typing.type_check_only
    class AccountsResource(googleapiclient.discovery.Resource):
        @typing.type_check_only
        class ConversionSourcesResource(googleapiclient.discovery.Resource):
            def create(
                self, *, parent: str, body: ConversionSource = ..., **kwargs: typing.Any
            ) -> ConversionSourceHttpRequest: ...
            def delete(
                self, *, name: str, **kwargs: typing.Any
            ) -> EmptyHttpRequest: ...
            def get(
                self, *, name: str, **kwargs: typing.Any
            ) -> ConversionSourceHttpRequest: ...
            def list(
                self,
                *,
                parent: str,
                pageSize: int = ...,
                pageToken: str = ...,
                showDeleted: bool = ...,
                **kwargs: typing.Any,
            ) -> ListConversionSourcesResponseHttpRequest: ...
            def list_next(
                self,
                previous_request: ListConversionSourcesResponseHttpRequest,
                previous_response: ListConversionSourcesResponse,
            ) -> ListConversionSourcesResponseHttpRequest | None: ...
            def patch(
                self,
                *,
                name: str,
                body: ConversionSource = ...,
                updateMask: str = ...,
                **kwargs: typing.Any,
            ) -> ConversionSourceHttpRequest: ...
            def undelete(
                self,
                *,
                name: str,
                body: UndeleteConversionSourceRequest = ...,
                **kwargs: typing.Any,
            ) -> ConversionSourceHttpRequest: ...

        def conversionSources(self) -> ConversionSourcesResource: ...

    def new_batch_http_request(
        self,
        callback: collections.abc.Callable[
            [
                str,
                googleapiclient.http.HttpRequest,
                googleapiclient.errors.HttpError | None,
            ],
            typing.Any,
        ]
        | None = None,
    ) -> googleapiclient.http.BatchHttpRequest: ...
    def accounts(self) -> AccountsResource: ...

@typing.type_check_only
class ConversionSourceHttpRequest(googleapiclient.http.HttpRequest):
    def execute(
        self,
        http: httplib2.Http | googleapiclient.http.HttpMock | None = None,
        num_retries: int = 0,
    ) -> ConversionSource: ...

@typing.type_check_only
class EmptyHttpRequest(googleapiclient.http.HttpRequest):
    def execute(
        self,
        http: httplib2.Http | googleapiclient.http.HttpMock | None = None,
        num_retries: int = 0,
    ) -> Empty: ...

@typing.type_check_only
class ListConversionSourcesResponseHttpRequest(googleapiclient.http.HttpRequest):
    def execute(
        self,
        http: httplib2.Http | googleapiclient.http.HttpMock | None = None,
        num_retries: int = 0,
    ) -> ListConversionSourcesResponse: ...
